package cat.hack3.codingtests.marsrover.cartography;

public record Coordinates(Latitude latitude, Longitude longitude) {

    public static Coordinates of(long latitude, long longitude) {
        return new Coordinates(Latitude.of(latitude), Longitude.of(longitude));
    }

    public Coordinates withUpdated(Latitude newLatitude) {
        return Coordinates.of(newLatitude.pointer, longitude.pointer);
    }

    public Coordinates withUpdated(Longitude newLongitude) {
        return Coordinates.of(latitude.pointer, newLongitude.pointer);
    }

    record Latitude(long pointer) {
        static Latitude of(long pointer) {
            return new Latitude(pointer);
        }
        @Override
        public String toString() {
            return String.valueOf(pointer);
        }
    }
    record Longitude(long pointer) {
        static Longitude of(long pointer) {
            return new Longitude(pointer);
        }
        @Override
        public String toString() {
            return String.valueOf(pointer);
        }
    }

}
